<?php
/**
 * @package MOD_JOOMICON for Joomla! 2.x+
 * @version $Id: installer.php 1.0.0 2015-12-17 12:00:00
 * @author Terry W. Carter
 * @copyright (C) 2015 - Terry W. Carter
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
 
//NO DIRECT ACCESS
defined('_JEXEC') or die;

class mod_joomiconInstallerScript
{
 	function postflight($type, $parent)
	{
		jimport('joomla.filesystem.file');
		$jversion = new JVERSION();
		
		//DETERMINE JOOMLA VERSION AND HANDLE EXCESS FILES
		if(version_compare(JVERSION,'3.0.0','ge')) {
			//DELETE INSTALLER ONLY MANIFEST
			JFile::delete('modules/mod_joomicon/mod_joomicon.xml');
			
			//HANDLE FILE COPY FOR ROOT FILES
			$filesrc = 'modules/mod_joomicon/versions/jv30/';
			$filedest = 'modules/mod_joomicon/';
			$filenames = JFolder::files($filesrc, '.', false, false);
				foreach($filenames as $file){
					JFile::copy($filesrc . $file, $filedest . $file);
				}
			
			//HANDLE FOLDER CREATION AND COPY
			$foldersrc = 'modules/mod_joomicon/versions/jv30/';
			$folderdest = 'modules/mod_joomicon/';
			$foldernames = JFolder::folders($foldersrc, '.', false, false);
				foreach($foldernames as $folder){
					if(!JFolder::exists($folderdest . $folder)){
						JFolder::create($folderdest . $folder);
					}
					JFolder::copy($foldersrc . $folder, $folderdest . $folder, '', true);
				}
			
			//INSTALL THE KDICONS MODULE
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
		
			//GET KDICONS MODULE ID
			$query->select("id")
				->from("#__modules")
				->where("module = 'mod_joomicon'");
			$db->setQuery($query);
			$moduleid = $db->loadResult();
		
				if (is_numeric($moduleid)) {
					//SET KDICONS TO PUBLISHED AND ADD TO ICON POSITION
					$query = $db->getQuery(TRUE);
					$query->update('#__modules')
						->set("title = 'JoomIcon'")
						->set("published = '1'")
						->set("position = 'icon'")
						->set("access = '3'")
						->where("id = " . (int) $moduleid);
					$db->setQuery($query);
					$db->query();
					
					//INSERT INTO MODULES MENU ITEMS
					$query = $db->getQuery(TRUE);
					$sql = "REPLACE INTO #__modules_menu VALUES ('$moduleid',0)";
					$db->setQuery($sql);
					$db->query();
				}
		
			//DISABLE DEFAULT QUICKICONS
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
		
			//GET QUICKICONS MODULE ID
			$query->select("id")
				->from("#__modules")
				->where('module = "mod_quickicon"');
			$db->setQuery($query);
			$quickiconid = $db->loadResult();
		
				if(is_numeric($quickiconid)){
					//SET QUICKICONS TO UNPUBLISHED
					$query = $db->getQuery(TRUE);
					$query->update("#__modules")
						->set("published = '0'")
						->where("id = ".$quickiconid);
					$db->setQuery($query);
					$db->query();
				}

			//SET THE PLUGIN PARAMETERS FOR THE JOOMLA UPDATE AND EXTENSION UPDATE SYSTEM
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$query->update('#__extensions')
				->set('params = "{\"context\":\"mod_joomicon\"}"')
				->where('name = "plg_quickicon_extensionupdate"');
			$db->setQuery($query);
			$db->query();
		
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$query->update('#__extensions')
				->set('params = "{\"context\":\"mod_joomicon\"}"')
				->where('name = "plg_quickicon_joomlaupdate"');
			$db->setQuery($query);
			$db->query();

			//DELETE THE VERSIONS FOLDER AND INSTALLER FILE
			JFolder::delete($filedest . 'versions');
			JFile::delete($filedest . 'installer.php');
						
		}else{
			
			//DELETE INSTALLER ONLY MANIFEST
			JFile::delete('modules/mod_joomicon/mod_joomicon.xml');
			
			//HANDLE FILE COPY FOR ROOT FILES
			$filesrc = 'modules/mod_joomicon/versions/jv25/';
			$filedest = 'modules/mod_joomicon/';
			$filenames = JFolder::files($filesrc, '.', false, false);
				foreach($filenames as $file){
					JFile::copy($filesrc . $file, $filedest . $file);
				}
			
			//HANDLE FOLDER CREATION AND COPY
			$foldersrc = 'modules/mod_joomicon/versions/jv25/';
			$folderdest = 'modules/mod_joomicon/';
			$foldernames = JFolder::folders($foldersrc, '.', false, false);
				foreach($foldernames as $folder){
					if(!JFolder::exists($folderdest . $folder)){
						JFolder::create($folderdest . $folder);
					}
					JFolder::copy($foldersrc . $folder, $folderdest . $folder, '', true);	
				}

			//DELETE THE VERSIONS FOLDER AND INSTALLER FILE
			JFolder::delete($filedest . 'versions');
			JFile::delete($filedest . 'installer.php');
			
			//INSTALL THE KDICONS MODULE
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
		
			//GET KDICONS MODULE ID
			$query->select('id')
				->from('#__modules')
				->where('module = "mod_joomicon"');
			$db->setQuery($query);
			$moduleid = $db->loadResult();
		
			if($moduleid){
				//SET KDICONS TO PUBLISHED AND ADD TO ICON POSITION
				$query = $db->getQuery(TRUE);
				$query->update('#__modules')
					->set('title = "JoomIcon"')
					->set('published = 1')
					->set('position = "icon"')
					->set("access = '3'")
					->where('id = ' . (int) $moduleid);
				$db->setQuery($query);
			
					//ASSIGN MODULE TO ALL MENU ITEMS
					if ($db->query()) {
						$query = $db->getQuery(TRUE);
						// was having problems using menuid, maybe because it was-- 0???
						$query->select('moduleid')
							->from('#__modules_menu')
							->where('moduleid = ' . (int) $moduleid);
						$db->setQuery($query);
						$existingid = $db->loadResult();

						if (!($existingid)) { 
							// now insert the menu row!!
							$query = $db->getQuery(TRUE);
							$query->insert('#__modules_menu')
								->columns('moduleid, menuid')
								->values((int) $moduleid . ', ' . 0);
							$db->setQuery($query);
							if (!($db->query())) {
								Jerror::raiseWarning(null, JText::_('Error: Could Not Modify Menu Table') . ' ' . $db->getErrorMsg());
							}
						}
					} else {
						Jerror::raiseWarning(null, JText::_('Error: Could Not Modify JoomIcon module') . ' ' . $db->getErrorMsg());
					}
					$db->query();
				} else {
					Jerror::raiseWarning(null, JText::_('Error: Module Not Found') . ' ' . $db->getErrorMsg());
				}
				$parent->set('message', JText::_('Post Flight Completed. Disabling the Default QuickIcon Module Now.') . $this->release);
		
			//DISABLE DEFAULT QUICKICONS
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
		
			//GET QUICKICONS MODULE ID
			$query->select('id')
				->from('#__modules')
				->where('module = "mod_quickicon"');
			$db->setQuery($query);
			$quickiconid = $db->loadResult();
		
			if ($quickiconid) {
			//SET QUICKICONS TO UNPUBLISHED
				$query = $db->getQuery(TRUE);
				$query->update('#__modules')
					->set('published = 0')
					->where('id = ' . (int) $quickiconid);
				$db->setQuery($query);
				$db->query();
			}
		
			//SET THE PLUGIN PARAMETERS FOR THE JOOMLA UPDATE AND EXTENSION UPDATE SYSTEM
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$query->update('#__extensions')
				->set('params = "{\"context\":\"mod_joomicon\"}"')
				->where('name = "plg_quickicon_extensionupdate"');
			$db->setQuery($query);
			$db->query();
		
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$query->update('#__extensions')
				->set('params = "{\"context\":\"mod_joomicon\"}"')
				->where('name = "plg_quickicon_joomlaupdate"');
			$db->setQuery($query);
			$db->query();
			
			if(!JFolder::exists( "../images/joomicon")){
				JFolder::create( "../images/joomicon");
			}

			//First we set up parameters
			$imgpath = "modules/mod_joomicon/joomicon/";
 
			//READ ALL PNG FILES INTO ARRAY
			$png_files = JFolder::files( $imgpath, '.png');
 
			//MOVE ICONPACK ICONS TO IMAGES FOLDER
			foreach ($png_files as $file) {
				JFile::move($imgpath. '/' . $file, "../images/joomicon/" . $file);
			}
		}	
	}
}
