<?php
/**
 * @package MOD_JOOMICON for Joomla! 3.0
 * @version $Id: helper.php 1.0.0 2015-12-17 12:00:00
 * @author Terry Carter
 * @copyright (C) 2015 - Terry W. Carter
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

//NO DIRECT ACCESS
defined('_JEXEC') or die;

abstract class modJoomIconHelper
{
	protected static $buttons = array();
	protected static $customentry1 = array();
	protected static $customentry2 = array();
	protected static $customentry3 = array();
	protected static $customentry4 = array();
	protected static $customentry5 = array();

	public static function &getButtons($params)
	{
		$key = (string)$params;
		if (!isset(self::$buttons[$key])) {
			$context = $params->get('context', 'mod_joomicon');
			if ($context == 'mod_joomicon')
			{
			// Load mod_joomicon language file in case this method is called before rendering the module
			JFactory::getLanguage()->load('mod_joomicon');
			
			//CUSTOM LINK 1 VARIABLES
			$title1 = $params->get("joomicon-title-one", "");
			$url1 = $params->get("joomicon-url-one", "");
			$urltarget1 = $params->get("joomicon-target-one", "");
			$customimg1 = $params->get("joomicon-img-one-custom", "");
			$stockimg1 = $params->get("joomicon-img-one-stock", "");			
			if($customimg1 != ""){
				$image1 = JUri::root() . $customimg1;
			}
			else if($stockimg1 != '-1'){
				$image1 = 'header/'.$stockimg1;
			}
			$access1 = $params->get("joomicon-access-one", "");
			$linkenabled1 = $params->get("joomicon-enabled-one", "");
			
			//CUSTOM LINK 2 VARIABLES
			$title2 = $params->get("joomicon-title-two", "");
			$url2 = $params->get("joomicon-url-two", "");
			$urltarget2 = $params->get("joomicon-target-two", "");
			$customimg2 = $params->get("joomicon-img-two-custom", "");
			$stockimg2 = $params->get("joomicon-img-two-stock", "");
			if($customimg2 != '-1'){
				$image2 = JUri::root() . $customimg2;
			}
			else if($stockimg2 != '-1'){
				$image2 = 'header/'.$stockimg2;
			}
			$access2 = $params->get("joomicon-access-two", "");
			$linkenabled2 = $params->get("joomicon-enabled-two", "");
			
			//CUSTOM LINK 3 VARIABLES
			$title3 = $params->get("joomicon-title-three", "");
			$url3 = $params->get("joomicon-url-three", "");
			$urltarget3 = $params->get("joomicon-target-three", "");
			$customimg3 = $params->get("joomicon-img-three-custom", "");
			$stockimg3 = $params->get("joomicon-img-three-stock", "");
			if($customimg3 != '-1'){
				$image3 = JUri::root() . $customimg3;
			}
			else if($stockimg3 != '-1'){
				$image3 = 'header/'.$stockimg3;
			}
			$access3 = $params->get("joomicon-access-three", "");
			$linkenabled3 = $params->get("joomicon-enabled-three", "");
			
			//CUSTOM LINK 4 VARIABLES
			$title4 = $params->get("joomicon-title-four", "");
			$url4 = $params->get("joomicon-url-four", "");
			$urltarget4 = $params->get("joomicon-target-four", "");
			$customimg4 = $params->get("joomicon-img-four-custom", "");
			$stockimg4 = $params->get("joomicon-img-four-stock", "");
			if($customimg4 != '-1'){
				$image4 = JUri::root() . $customimg4;
			}
			else if($stockimg4 != '-1'){
				$image4 = 'header/'.$stockimg4;
			}
			$access4 = $params->get("joomicon-access-four", "");
			$linkenabled4 = $params->get("joomicon-enabled-four", "");
			
			//CUSTOM LINK 5 VARIABLES
			$title5 = $params->get("joomicon-title-five", "");
			$url5 = $params->get("joomicon-url-five", "");
			$urltarget5 = $params->get("joomicon-target-five", "");
			$customimg5 = $params->get("joomicon-img-five-custom", "");
			$stockimg5 = $params->get("joomicon-img-five-stock", "");
			if($customimg5 != '-1'){
				$image5 = JUri::root() . $customimg5;
			}
			else if($stockimg5 != '-1'){
				$image5 = 'header/'.$stockimg5;
			}
			$access5 = $params->get("joomicon-access-five", "");
			$linkenabled5 = $params->get("joomicon-enabled-five", "");
				
				self::$buttons[$key] = array(
					array(
						'link' => JRoute::_('index.php?option=com_content&task=article.add'),
						'target' => '_self',
						'image' => 'header/icon-48-article-add.png',
						'text' => JText::_('MOD_JOOMICON_ADD_NEW_ARTICLE'),
						'access' => array('core.manage', 'com_content', 'core.create', 'com_content', )
					),
					array(
						'link' => JRoute::_('index.php?option=com_content'),
						'target' => '_self',
						'image' => 'header/icon-48-article.png',
						'text' => JText::_('MOD_JOOMICON_ARTICLE_MANAGER'),
						'access' => array('core.manage', 'com_content')
					),
					array(
						'link' => JRoute::_('index.php?option=com_categories&extension=com_content'),
						'target' => '_self',
						'image' => 'header/icon-48-category.png',
						'text' => JText::_('MOD_JOOMICON_CATEGORY_MANAGER'),
						'access' => array('core.manage', 'com_content')
					),
					array(
						'link' => JRoute::_('index.php?option=com_media'),
						'target' => '_self',
						'image' => 'header/icon-48-media.png',
						'text' => JText::_('MOD_JOOMICON_MEDIA_MANAGER'),
						'access' => array('core.manage', 'com_media')
					),
					array(
						'link' => JRoute::_('index.php?option=com_menus'),
						'target' => '_self',
						'image' => 'header/icon-48-menumgr.png',
						'text' => JText::_('MOD_JOOMICON_MENU_MANAGER'),
						'access' => array('core.manage', 'com_menus')
					),
					array(
						'link' => JRoute::_('index.php?option=com_users'),
						'target' => '_self',
						'image' => 'header/icon-48-user.png',
						'text' => JText::_('MOD_JOOMICON_USER_MANAGER'),
						'access' => array('core.manage', 'com_users')
					),
					array(
						'link' => JRoute::_('index.php?option=com_modules'),
						'target' => '_self',
						'image' => 'header/icon-48-module.png',
						'text' => JText::_('MOD_JOOMICON_MODULE_MANAGER'),
						'access' => array('core.manage', 'com_modules')
					),
					array(
						'link' => JRoute::_('index.php?option=com_installer'),
						'target' => '_self',
						'image' => 'header/icon-48-extension.png',
						'text' => JText::_('MOD_JOOMICON_EXTENSION_MANAGER'),
						'access' => array('core.manage', 'com_installer')
					),
					array(
						'link' => JRoute::_('index.php?option=com_languages'),
						'target' => '_self',
						'image' => 'header/icon-48-language.png',
						'text' => JText::_('MOD_JOOMICON_LANGUAGE_MANAGER'),
						'access' => array('core.manage', 'com_languages')
					),
					array(
						'link' => JRoute::_('index.php?option=com_config'),
						'target' => '_self',
						'image' => 'header/icon-48-config.png',
						'text' => JText::_('MOD_JOOMICON_GLOBAL_CONFIGURATION'),
						'access' => array('core.manage', 'com_config', 'core.admin', 'com_config')
					),
					array(
						'link' => JRoute::_('index.php?option=com_templates'),
						'target' => '_self',
						'image' => 'header/icon-48-themes.png',
						'text' => JText::_('MOD_JOOMICON_TEMPLATE_MANAGER'),
						'access' => array('core.manage', 'com_templates')
					),
					array(
						'link' => JRoute::_('index.php?option=com_admin&task=profile.edit&id='.JFactory::getUser()->id),
						'target' => '_self',
						'image' => 'header/icon-48-user-profile.png',
						'text' => JText::_('MOD_JOOMICON_PROFILE'),
						'access' => true
					),
				);
				if($linkenabled5 == 1){
					$customentry5[$key] = array(
						array(
						'link' => $url5,
						'target' => $urltarget5,
						'image' => $image5,
						'text' => $title5,
						'access' => array($access5)
						),
					);
					self::$buttons[$key] = array_merge($customentry5[$key], self::$buttons[$key]);
				}
				if($linkenabled4 == 1){
					$customentry4[$key] = array(
						array(
						'link' => $url4,
						'target' => $urltarget4,
						'image' => $image4,
						'text' => $title4,
						'access' => array($access4)
						),
					);
					self::$buttons[$key] = array_merge($customentry4[$key], self::$buttons[$key]);
				}
				if($linkenabled3 == 1){
					$customentry3[$key] = array(
						array(
						'link' => $url3,
						'target' => $urltarget3,
						'image' => $image3,
						'text' => $title3,
						'access' => array($access3)
						),
					);
					self::$buttons[$key] = array_merge($customentry3[$key], self::$buttons[$key]);
				}
				if($linkenabled2 == 1){
					$customentry2[$key] = array(
						array(
						'link' => $url2,
						'target' => $urltarget2,
						'image' => $image2,
						'text' => $title2,
						'access' => array($access2)
						),
					);
					self::$buttons[$key] = array_merge($customentry2[$key], self::$buttons[$key]);
				}
				if($linkenabled1 == 1){
					$customentry1[$key] = array(
						array(
						'link' => $url1,
						'target' => $urltarget1,
						'image' => $image1,
						'text' => $title1,
						'access' => array($access1)
						),
					);
					self::$buttons[$key] = array_merge($customentry1[$key], self::$buttons[$key]);
				}
			}
			else
			{
				self::$buttons[$key] = array();
			}

			// Include buttons defined by published quickicon plugins
			JPluginHelper::importPlugin('quickicon');
			$app = JFactory::getApplication();
			$arrays = (array) $app->triggerEvent('onGetIcons', array($context));

			foreach ($arrays as $response) {
				foreach ($response as $icon) {
					$default = array(
						'link' => null,
						'target' => null,
						'image' => 'header/icon-48-config.png',
						'text' => null,
						'access' => true
					);
					$icon = array_merge($default, $icon);
					if (!is_null($icon['link']) && !is_null($icon['text'])) {
						self::$buttons[$key][] = $icon;
					}
				}
			}
		}

		return self::$buttons[$key];
	}

	public static function getTitle($params, $module)
	{
		$key = $params->get('context', 'mod_joomicon') . '_title';
		if (JFactory::getLanguage()->hasKey($key))
		{
			return JText::_($key);
		}
		else
		{
			return $module->title;
		}
	}
}
