<?php
/**
 * @package MOD_JOOMICON for Joomla! 3.0
 * @version $Id: helper.php 1.0.0 2015-12-17 12:00:00
 * @author Terry Carter
 * @copyright (C) 2015 - Terry W. Carter
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

//NO DIRECT ACCESS
defined('_JEXEC') or die;

abstract class modJoomIconHelper
{
	protected static $buttons = array();
	protected static $customentry1 = array();
	protected static $customentry2 = array();
	protected static $customentry3 = array();
	protected static $customentry4 = array();
	protected static $customentry5 = array();

	public static function &getButtons($params)
	{
		$key = (string)$params;
		if (!isset(self::$buttons[$key])) {
			$context = $params->get('context', 'mod_joomicon');
			if ($context == 'mod_joomicon')
			{
			// Load mod_joomicon language file in case this method is called before rendering the module
			JFactory::getLanguage()->load('mod_joomicon');
			
			//CUSTOM LINK 1 VARIABLES
			$title1 = $params->get("joomicon-title-one", "");
			$link1group = $params->get("joomicon-group-one", "");
			$url1 = $params->get("joomicon-url-one", "");
			$urltarget1 = $params->get("joomicon-target-one", "");
			$access1 = $params->get("joomicon-access-one", "");
			$linkenabled1 = $params->get("joomicon-enabled-one", "");
			
			//CUSTOM LINK 2 VARIABLES
			$title2 = $params->get("joomicon-title-two", "");
			$link2group = $params->get("joomicon-group-two", "");
			$url2 = $params->get("joomicon-url-two", "");
			$urltarget2 = $params->get("joomicon-target-two", "");
			$access2 = $params->get("joomicon-access-two", "");
			$linkenabled2 = $params->get("joomicon-enabled-two", "");
			
			//CUSTOM LINK 3 VARIABLES
			$title3 = $params->get("joomicon-title-three", "");
			$link3group = $params->get("joomicon-group-three", "");
			$url3 = $params->get("joomicon-url-three", "");
			$urltarget3 = $params->get("joomicon-target-three", "");
			$access3 = $params->get("joomicon-access-three", "");
			$linkenabled3 = $params->get("joomicon-enabled-three", "");
			
			//CUSTOM LINK 4 VARIABLES
			$title4 = $params->get("joomicon-title-four", "");
			$link4group = $params->get("joomicon-group-four", "");
			$url4 = $params->get("joomicon-url-four", "");
			$urltarget4 = $params->get("joomicon-target-four", "");
			$access4 = $params->get("joomicon-access-four", "");
			$linkenabled4 = $params->get("joomicon-enabled-four", "");
			
			//CUSTOM LINK 5 VARIABLES
			$title5 = $params->get("joomicon-title-five", "");
			$link5group = $params->get("joomicon-group-five", "");
			$url5 = $params->get("joomicon-url-five", "");
			$urltarget5 = $params->get("joomicon-target-five", "");
			$access5 = $params->get("joomicon-access-five", "");
			$linkenabled5 = $params->get("joomicon-enabled-five", "");
				
				self::$buttons[$key] = array(
					array(
						'link' => JRoute::_('index.php?option=com_content&task=article.add'),
						'image' => 'pencil-2',
						'icon' => 'header/icon-48-article-add.png',
						'text' => JText::_('MOD_JOOMICON_ADD_NEW_ARTICLE'),
						'access' => array('core.manage', 'com_content', 'core.create', 'com_content'),
						'group' => 'MOD_JOOMICON_CONTENT'
					),
					array(
						'link' => JRoute::_('index.php?option=com_content'),
						'image' => 'stack',
						'icon' => 'header/icon-48-article.png',
						'text' => JText::_('MOD_JOOMICON_ARTICLE_MANAGER'),
						'access' => array('core.manage', 'com_content'),
						'group' => 'MOD_JOOMICON_CONTENT'
					),
					array(
						'link' => JRoute::_('index.php?option=com_categories&extension=com_content'),
						'image' => 'folder',
						'icon' => 'header/icon-48-category.png',
						'text' => JText::_('MOD_JOOMICON_CATEGORY_MANAGER'),
						'access' => array('core.manage', 'com_content'),
						'group' => 'MOD_JOOMICON_CONTENT'
					),
					array(
						'link' => JRoute::_('index.php?option=com_media'),
						'image' => 'pictures',
						'icon' => 'header/icon-48-media.png',
						'text' => JText::_('MOD_JOOMICON_MEDIA_MANAGER'),
						'access' => array('core.manage', 'com_media'),
						'group' => 'MOD_JOOMICON_CONTENT'
					),
					array(
						'link' => JRoute::_('index.php?option=com_menus'),
						'image' => 'list-view',
						'icon' => 'header/icon-48-menumgr.png',
						'text' => JText::_('MOD_JOOMICON_MENU_MANAGER'),
						'access' => array('core.manage', 'com_menus'),
						'group' => 'MOD_JOOMICON_STRUCTURE'
					),
					array(
						'link' => JRoute::_('index.php?option=com_users'),
						'image' => 'users',
						'icon' => 'header/icon-48-user.png',
						'text' => JText::_('MOD_JOOMICON_USER_MANAGER'),
						'access' => array('core.manage', 'com_users'),
						'group' => 'MOD_JOOMICON_USERS'
					),
					array(
						'link' => JRoute::_('index.php?option=com_modules'),
						'image' => 'cube',
						'icon' => 'header/icon-48-module.png',
						'text' => JText::_('MOD_JOOMICON_MODULE_MANAGER'),
						'access' => array('core.manage', 'com_modules'),
						'group' => 'MOD_JOOMICON_STRUCTURE'
					),
					array(
						'link' => JRoute::_('index.php?option=com_config'),
						'image' => 'cog',
						'icon' => 'header/icon-48-config.png',
						'text' => JText::_('MOD_JOOMICON_GLOBAL_CONFIGURATION'),
						'access' => array('core.manage', 'com_config', 'core.admin', 'com_config'),
						'group' => 'MOD_JOOMICON_CONFIGURATION'
					),
					array(
						'link' => JRoute::_('index.php?option=com_templates'),
						'image' => 'eye',
						'icon' => 'header/icon-48-themes.png',
						'text' => JText::_('MOD_JOOMICON_TEMPLATE_MANAGER'),
						'access' => array('core.manage', 'com_templates'),
						'group' => 'MOD_JOOMICON_CONFIGURATION'
					),
					array(
						'link' => JRoute::_('index.php?option=com_languages'),
						'image' => 'comments-2',
						'icon' => 'header/icon-48-language.png',
						'text' => JText::_('MOD_JOOMICON_LANGUAGE_MANAGER'),
						'access' => array('core.manage', 'com_languages'),
						'group' => 'MOD_JOOMICON_CONFIGURATION'
					),
					array(
						'link' => JRoute::_('index.php?option=com_installer'),
						'image' => 'download',
						'icon' => 'header/icon-48-extension.png',
						'text' => JText::_('MOD_JOOMICON_INSTALL_EXTENSIONS'),
						'access' => array('core.manage', 'com_installer'),
						'group' => 'MOD_JOOMICON_EXTENSIONS'
					),
				);
				if($linkenabled5){
					$customentry5[$key] = array(
						array(
						'link' => $url5,
						'target' => $urltarget5,
						'image' => 'arrow-right',
						'text' => $title5,
						'access' => array($access5),
						'group' => $link5group
						),
					);
					self::$buttons[$key] = array_merge($customentry5[$key], self::$buttons[$key]);
				}
				if($linkenabled4){
					$customentry4[$key] = array(
						array(
						'link' => $url4,
						'target' => $urltarget4,
						'image' => 'arrow-right',
						'text' => $title4,
						'access' => array($access4),
						'group' => $link4group
						),
					);
					self::$buttons[$key] = array_merge($customentry4[$key], self::$buttons[$key]);
				}
				if($linkenabled3){
					$customentry3[$key] = array(
						array(
						'link' => $url3,
						'target' => $urltarget3,
						'image' => 'arrow-right',
						'text' => $title3,
						'access' => array($access3),
						'group' => $link3group
						),
					);
					self::$buttons[$key] = array_merge($customentry3[$key], self::$buttons[$key]);
				}
				if($linkenabled2){
					$customentry2[$key] = array(
						array(
						'link' => $url2,
						'target' => $urltarget2,
						'image' => 'arrow-right',
						'text' => $title2,
						'access' => array($access2),
						'group' => $link2group
						),
					);
					self::$buttons[$key] = array_merge($customentry2[$key], self::$buttons[$key]);
				}
				if($linkenabled1){
					$customentry1[$key] = array(
						array(
						'link' => $url1,
						'target' => $urltarget1,
						'image' => 'arrow-right',
						'text' => $title1,
						'access' => array($access1),
						'group' => $link1group
						),
					);
					self::$buttons[$key] = array_merge($customentry1[$key], self::$buttons[$key]);
				}
			}
			else
			{
				self::$buttons[$key] = array();
			}

			// Include buttons defined by published quickicon plugins
			JPluginHelper::importPlugin('quickicon');
			$app = JFactory::getApplication();
			$arrays = (array) $app->triggerEvent('onGetIcons', array($context));

			foreach ($arrays as $response)
			{
				foreach ($response as $icon)
				{
					$default = array(
						'link' => null,
						'image' => 'cog',
						'text' => null,
						'access' => true,
						'group' => 'MOD_JOOMICON_EXTENSIONS'
					);
					$icon = array_merge($default, $icon);

					if (!is_null($icon['link']) && !is_null($icon['text']))
					{
						self::$buttons[$key][] = $icon;
					}
				}
			}
		}

		return self::$buttons[$key];
	}
	
	public static function groupButtons($buttons)
	{
		$groupedButtons = array();

		foreach ($buttons as $button)
		{
			$groupedButtons[$button['group']][] = $button;
		}
		return $groupedButtons;
	}

	public static function getTitle($params, $module)
	{
		$key = $params->get('context', 'mod_joomicon') . '_title';
		if (JFactory::getLanguage()->hasKey($key))
		{
			return JText::_($key);
		}
		else
		{
			return $module->title;
		}
	}
}
